import {
  Application,
  Domain,
  asyncLocalStorage,
} from '@bitloops/bl-boilerplate-core';
type TChangeEmailCommand = {
  email: string;
  userId: string;
};
export class ChangeEmailCommand extends Application.Command {
  public readonly email: string;
  public readonly userId: string;
  public readonly metadata: Application.TCommandMetadata = {
    boundedContextId: 'iam',
    createdTimestamp: Date.now(),
    messageId: new Domain.UUIDv4().toString(),
    correlationId: asyncLocalStorage.getStore()?.get('correlationId'),
    context: asyncLocalStorage.getStore()?.get('context'),
  };
  constructor(changeEmailRequestDTO: TChangeEmailCommand) {
    super();
    this.email = changeEmailRequestDTO.email;
    this.userId = changeEmailRequestDTO.userId;
  }
}
