import { Domain, asyncLocalStorage } from '@bitloops/bl-boilerplate-core';
type UserChangedEmailDomainEventProps = {
  email: string;
  password: string;
  lastLogin: string;
} & {
  aggregateId: string;
};

export class UserChangedEmailDomainEvent
  implements Domain.IDomainEvent<UserChangedEmailDomainEventProps>
{
  public readonly aggregateId: string;
  public readonly metadata: Domain.TDomainEventMetadata = {
    boundedContextId: 'iam',
    createdTimestamp: Date.now(),
    messageId: new Domain.UUIDv4().toString(),
    correlationId: asyncLocalStorage.getStore()?.get('correlationId'),
    context: asyncLocalStorage.getStore()?.get('context'),
  };
  constructor(public readonly payload: UserChangedEmailDomainEventProps) {
    this.aggregateId = payload.aggregateId;
  }
}
