import {
  Application,
  Domain,
  asyncLocalStorage,
} from '@bitloops/bl-boilerplate-core';
type TChangeUserEmailCommand = {
  email: string;
  userId: string;
};
export class ChangeUserEmailCommand extends Application.Command {
  public readonly email: string;
  public readonly userId: string;
  public readonly metadata: Application.TCommandMetadata = {
    boundedContextId: 'marketing',
    createdTimestamp: Date.now(),
    messageId: new Domain.UUIDv4().toString(),
    correlationId: asyncLocalStorage.getStore()?.get('correlationId'),
    context: asyncLocalStorage.getStore()?.get('context'),
  };
  constructor(changeUserEmailRequestDTO: TChangeUserEmailCommand) {
    super();
    this.email = changeUserEmailRequestDTO.email;
    this.userId = changeUserEmailRequestDTO.userId;
  }
}
