import {
  Application,
  Domain,
  asyncLocalStorage,
} from '@bitloops/bl-boilerplate-core';
type TCreateUserCommand = {
  email: string;
  userId: string;
};
export class CreateUserCommand extends Application.Command {
  public readonly email: string;
  public readonly userId: string;
  public readonly metadata: Application.TCommandMetadata = {
    boundedContextId: 'marketing',
    createdTimestamp: Date.now(),
    messageId: new Domain.UUIDv4().toString(),
    correlationId: asyncLocalStorage.getStore()?.get('correlationId'),
    context: asyncLocalStorage.getStore()?.get('context'),
  };
  constructor(createUserRequestDTO: TCreateUserCommand) {
    super();
    this.email = createUserRequestDTO.email;
    this.userId = createUserRequestDTO.userId;
  }
}
