import {
  Application,
  Domain,
  asyncLocalStorage,
} from '@bitloops/bl-boilerplate-core';
type TIncrementTodosCommand = {
  id: string;
};
export class IncrementTodosCommand extends Application.Command {
  public readonly id: string;
  public readonly metadata: Application.TCommandMetadata = {
    boundedContextId: 'marketing',
    createdTimestamp: Date.now(),
    messageId: new Domain.UUIDv4().toString(),
    correlationId: asyncLocalStorage.getStore()?.get('correlationId'),
    context: asyncLocalStorage.getStore()?.get('context'),
  };
  constructor(incrementTodosRequestDTO: TIncrementTodosCommand) {
    super();
    this.id = incrementTodosRequestDTO.id;
  }
}
