import {
  Application,
  Domain,
  asyncLocalStorage,
} from '@bitloops/bl-boilerplate-core';
type TSendEmailCommand = {
  destination: string;
  origin: string;
  content: string;
};
export class SendEmailCommand extends Application.Command {
  public readonly destination: string;
  public readonly origin: string;
  public readonly content: string;
  public readonly metadata: Application.TCommandMetadata = {
    boundedContextId: 'marketing',
    createdTimestamp: Date.now(),
    messageId: new Domain.UUIDv4().toString(),
    correlationId: asyncLocalStorage.getStore()?.get('correlationId'),
    context: asyncLocalStorage.getStore()?.get('context'),
  };
  constructor(sendEmailRequestDTO: TSendEmailCommand) {
    super();
    this.destination = sendEmailRequestDTO.destination;
    this.origin = sendEmailRequestDTO.origin;
    this.content = sendEmailRequestDTO.content;
  }
}
