import { Domain, asyncLocalStorage } from '@bitloops/bl-boilerplate-core';
type TodoCompletionsIncrementedDomainEventProps = {
  completedTodos: number;
} & {
  aggregateId: string;
};

export class TodoCompletionsIncrementedDomainEvent
  implements Domain.IDomainEvent<TodoCompletionsIncrementedDomainEventProps>
{
  public readonly aggregateId: string;
  public readonly metadata: Domain.TDomainEventMetadata = {
    boundedContextId: 'marketing',
    createdTimestamp: Date.now(),
    messageId: new Domain.UUIDv4().toString(),
    correlationId: asyncLocalStorage.getStore()?.get('correlationId'),
    context: asyncLocalStorage.getStore()?.get('context'),
  };
  constructor(
    public readonly payload: TodoCompletionsIncrementedDomainEventProps
  ) {
    this.aggregateId = payload.aggregateId;
  }
}
