import {
  Application,
  Domain,
  asyncLocalStorage,
} from '@bitloops/bl-boilerplate-core';
type TAddTodoCommand = {
  title: string;
};
export class AddTodoCommand extends Application.Command {
  public readonly title: string;
  public readonly metadata: Application.TCommandMetadata = {
    boundedContextId: 'todo',
    createdTimestamp: Date.now(),
    messageId: new Domain.UUIDv4().toString(),
    correlationId: asyncLocalStorage.getStore()?.get('correlationId'),
    context: asyncLocalStorage.getStore()?.get('context'),
  };
  constructor(addTodoRequestDTO: TAddTodoCommand) {
    super();
    this.title = addTodoRequestDTO.title;
  }
}
