import {
  Application,
  Domain,
  asyncLocalStorage,
} from '@bitloops/bl-boilerplate-core';
type TCompleteTodoCommand = {
  todoId: string;
};
export class CompleteTodoCommand extends Application.Command {
  public readonly todoId: string;
  public readonly metadata: Application.TCommandMetadata = {
    boundedContextId: 'todo',
    createdTimestamp: Date.now(),
    messageId: new Domain.UUIDv4().toString(),
    correlationId: asyncLocalStorage.getStore()?.get('correlationId'),
    context: asyncLocalStorage.getStore()?.get('context'),
  };
  constructor(completeTodoRequestDTO: TCompleteTodoCommand) {
    super();
    this.todoId = completeTodoRequestDTO.todoId;
  }
}
