import {
  Application,
  Domain,
  asyncLocalStorage,
} from '@bitloops/bl-boilerplate-core';
type TModifyTodoTitleCommand = {
  title: string;
  id: string;
};
export class ModifyTodoTitleCommand extends Application.Command {
  public readonly title: string;
  public readonly id: string;
  public readonly metadata: Application.TCommandMetadata = {
    boundedContextId: 'todo',
    createdTimestamp: Date.now(),
    messageId: new Domain.UUIDv4().toString(),
    correlationId: asyncLocalStorage.getStore()?.get('correlationId'),
    context: asyncLocalStorage.getStore()?.get('context'),
  };
  constructor(modifyTodoTitleRequestDTO: TModifyTodoTitleCommand) {
    super();
    this.title = modifyTodoTitleRequestDTO.title;
    this.id = modifyTodoTitleRequestDTO.id;
  }
}
