import { Domain, asyncLocalStorage } from '@bitloops/bl-boilerplate-core';
type TodoUncompletedDomainEventProps = {
  userId: string;
  title: string;
  completed: boolean;
} & {
  aggregateId: string;
};

export class TodoUncompletedDomainEvent
  implements Domain.IDomainEvent<TodoUncompletedDomainEventProps>
{
  public readonly aggregateId: string;
  public readonly metadata: Domain.TDomainEventMetadata = {
    boundedContextId: 'todo',
    createdTimestamp: Date.now(),
    messageId: new Domain.UUIDv4().toString(),
    correlationId: asyncLocalStorage.getStore()?.get('correlationId'),
    context: asyncLocalStorage.getStore()?.get('context'),
  };
  constructor(public readonly payload: TodoUncompletedDomainEventProps) {
    this.aggregateId = payload.aggregateId;
  }
}
